<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>net.ranides</groupId>
    <artifactId>assira.project</artifactId>
    <version>2.8.4-SNAPSHOT</version>
    <packaging>pom</packaging>

    <name>${project.groupId}:${project.artifactId}</name>
    <description>assira: general purpose java library.</description>

    <url>http://ranides.net/projects/assira</url>

    <developers>
        <developer>
            <name>Ranides Atterwim</name>
            <email>ranides@gmail.com</email>
            <organization>ranides.net</organization>
            <organizationUrl>https://ranides.net</organizationUrl>
        </developer>
    </developers>
    <licenses>
        <license>
            <name>WTFPL</name>
            <url>http://www.wtfpl.net</url>
        </license>
    </licenses>
    <scm>
        <connection>scm:git:https://git.ranides.net/projects/assira.git</connection>
        <developerConnection>scm:git:https://git.ranides.net/projects/assira.git</developerConnection>
        <url>https://git.ranides.net/projects/assira</url>
    </scm>
    <distributionManagement>
        <snapshotRepository>
            <id>ossrh</id>
            <url>https://s01.oss.sonatype.org/content/repositories/snapshots</url>
        </snapshotRepository>
        <repository>
            <id>ossrh</id>
            <url>https://s01.oss.sonatype.org/service/local/staging/deploy/maven2/</url>
        </repository>
    </distributionManagement>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <maven.compiler.source>1.8</maven.compiler.source>
        <maven.compiler.target>1.8</maven.compiler.target>
        <netbeans.hint.license>WTFPL</netbeans.hint.license>
        <assira.junit.debug>false</assira.junit.debug>
        <assira.junit.logger.level>debug</assira.junit.logger.level>

        <!-- this is last version of "antlr4" artifact compatible with JDK 8 (ANTLR 4 Tool) -->
        <antlr.version>4.9.3</antlr.version>

        <org-netbeans-modules-editor-indent.CodeStyle.project.text-line-wrap>none</org-netbeans-modules-editor-indent.CodeStyle.project.text-line-wrap>
        <org-netbeans-modules-editor-indent.CodeStyle.project.indent-shift-width>4</org-netbeans-modules-editor-indent.CodeStyle.project.indent-shift-width>
        <org-netbeans-modules-editor-indent.CodeStyle.project.spaces-per-tab>4</org-netbeans-modules-editor-indent.CodeStyle.project.spaces-per-tab>
        <org-netbeans-modules-editor-indent.CodeStyle.project.tab-size>4</org-netbeans-modules-editor-indent.CodeStyle.project.tab-size>
        <org-netbeans-modules-editor-indent.CodeStyle.project.text-limit-width>120</org-netbeans-modules-editor-indent.CodeStyle.project.text-limit-width>
        <org-netbeans-modules-editor-indent.CodeStyle.project.expand-tabs>true</org-netbeans-modules-editor-indent.CodeStyle.project.expand-tabs>
        <org-netbeans-modules-editor-indent.CodeStyle.usedProfile>project</org-netbeans-modules-editor-indent.CodeStyle.usedProfile>
    </properties>

    <modules>

    </modules>

    <profiles>
        <profile>
            <id>asm</id>
            <modules>
                <module>assira.asm</module>
            </modules>
        </profile>
        <profile>
            <id>common</id>
            <modules>
                <module>assira.junit</module>
                <module>assira.test</module>
                <module>assira.core</module>
                <module>assira.commons</module>
                <module>assira.ui</module>
                <module>assira.enterprise</module>
                <module>assira.xls</module>
                <module>assira.g4interpreter</module>
            </modules>
        </profile>
        <profile>
            <id>jdk8</id>
            <modules>
                <module>assira.core8</module>
            </modules>
        </profile>
        <profile>
            <id>jdk11</id>
            <modules>
                <module>assira.core11</module>
                <module>assira.lambda</module>
            </modules>
        </profile>
        <profile>
            <id>release</id>
            <activation>
                <activeByDefault>false</activeByDefault>
            </activation>
            <build>
                <plugins>
                    <plugin>
                        <groupId>org.apache.maven.plugins</groupId>
                        <artifactId>maven-source-plugin</artifactId>
                        <version>2.2.1</version>
                        <executions>
                            <execution>
                                <id>attach-sources</id>
                                <goals>
                                    <goal>jar-no-fork</goal>
                                </goals>
                            </execution>
                        </executions>
                    </plugin>
                    <plugin>
                        <groupId>org.apache.maven.plugins</groupId>
                        <artifactId>maven-javadoc-plugin</artifactId>
                        <version>3.3.1</version>
                        <executions>
                            <execution>
                                <id>attach-javadocs</id>
                                <goals>
                                    <goal>jar</goal>
                                </goals>
                            </execution>
                        </executions>
                        <configuration>
                            <version>true</version>
                            <show>public</show>
                            <doclint>none</doclint>
                        </configuration>
                    </plugin>
                    <plugin>
                        <groupId>org.apache.maven.plugins</groupId>
                        <artifactId>maven-gpg-plugin</artifactId>
                        <version>1.5</version>
                        <executions>
                            <execution>
                                <id>sign-artifacts</id>
                                <phase>verify</phase>
                                <goals>
                                    <goal>sign</goal>
                                </goals>
                            </execution>
                        </executions>
                    </plugin>
                </plugins>
            </build>
        </profile>
        <profile>
            <id>offline</id>
            <activation>
                <property>
                    <name>net.ranides.offline</name>
                </property>
            </activation>
            <build>
                <plugins>
                    <plugin>
                        <groupId>org.apache.maven.plugins</groupId>
                        <artifactId>maven-surefire-plugin</artifactId>
                        <configuration>
                            <excludedGroups>net.ranides.assira.junit.JCategories$Slow,net.ranides.assira.junit.JCategories$UnstableTest,net.ranides.assira.junit.JCategories$Online</excludedGroups>
                        </configuration>
                    </plugin>
                </plugins>
            </build>
        </profile>
        </profiles>

    <build>
        <extensions>
            <extension>
                <groupId>org.apache.maven.wagon</groupId>
                <artifactId>wagon-ftp</artifactId>
                <version>1.0</version>
            </extension>
        </extensions>

        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.8.1</version>
                <configuration>
                    <source>${maven.compiler.source}</source>
                    <target>${maven.compiler.target}</target>
                    <compilerArgument>-Xlint:unchecked</compilerArgument>
                    <compilerArgument>-parameters</compilerArgument>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>2.19.1</version>
                <configuration>
                    <systemPropertyVariables>
                        <assira.junit.debug>${assira.junit.debug}</assira.junit.debug>
                        <assira.version>${project.version}</assira.version>
                        <assira.junit.logger.level>${assira.junit.logger.level}</assira.junit.logger.level>
                    </systemPropertyVariables>
                    <testFailureIgnore>false</testFailureIgnore>
                    <skip>false</skip>
                    <excludedGroups>net.ranides.assira.junit.JCategories$Slow,net.ranides.assira.junit.JCategories$UnstableTest</excludedGroups>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-jxr-plugin</artifactId>
                <version>2.3</version>
            </plugin>
        </plugins>
    </build>

    <reporting>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-javadoc-plugin</artifactId>
                <version>2.9</version>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-jxr-plugin</artifactId>
                <version>2.3</version>
            </plugin>
        </plugins>
    </reporting>

    <dependencyManagement>
        <dependencies>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.commons</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.g4interpreter</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.core</artifactId>
                <version>${project.version}</version>
                <type>jar</type>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.core</artifactId>
                <version>${project.version}</version>
                <type>test-jar</type>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.core8</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.core11</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.asm</artifactId>
                <version>7.2</version>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.jdk8</artifactId>
                <version>${project.version}</version>
                <scope>runtime</scope>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.jdk11</artifactId>
                <version>${project.version}</version>
                <scope>runtime</scope>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.junit</artifactId>
                <version>${project.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>net.ranides</groupId>
                <artifactId>assira.lambda</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>junit</groupId>
                <artifactId>junit</artifactId>
                <version>4.13.2</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>org.slf4j</groupId>
                <artifactId>slf4j-api</artifactId>
                <version>1.7.13</version>
            </dependency>
            <dependency>
                <groupId>org.slf4j</groupId>
                <artifactId>slf4j-simple</artifactId>
                <version>1.7.13</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>net.sourceforge.pmd</groupId>
                <artifactId>pmd-java</artifactId>
                <version>5.3.3</version>
            </dependency>
            <dependency>
                <groupId>com.google.code.findbugs</groupId>
                <artifactId>annotations</artifactId>
                <version>3.0.1u2</version>
                <scope>provided</scope>
            </dependency>
            <dependency>
                <groupId>com.fasterxml.jackson.core</groupId>
                <artifactId>jackson-core</artifactId>
                <version>2.15.0</version>
            </dependency>
            <dependency>
                <groupId>com.fasterxml.jackson.core</groupId>
                <artifactId>jackson-databind</artifactId>
                <version>2.15.0</version>
            </dependency>
            <dependency>
                <groupId>com.fasterxml.jackson.datatype</groupId>
                <artifactId>jackson-datatype-json-org</artifactId>
                <version>2.15.0</version>
            </dependency>
            <dependency>
                <groupId>com.fasterxml.jackson.datatype</groupId>
                <artifactId>jackson-datatype-jsr310</artifactId>
                <version>2.15.0</version>
            </dependency>
            <dependency>
                <groupId>se.fishtank</groupId>
                <artifactId>css-selectors</artifactId>
                <version>2.0</version>
            </dependency>
            <dependency>
                <groupId>io.jsonwebtoken</groupId>
                <artifactId>jjwt</artifactId>
                <version>0.9.0</version>
            </dependency>
            <dependency>
                <groupId>org.projectlombok</groupId>
                <artifactId>lombok</artifactId>
                <version>1.18.20</version>
                <scope>provided</scope>
            </dependency>
            <dependency>
                <groupId>org.antlr</groupId>
                <artifactId>antlr4-runtime</artifactId>
                <version>${antlr.version}</version>
            </dependency>
            <dependency>
                <groupId>org.antlr</groupId>
                <artifactId>antlr4</artifactId>
                <version>${antlr.version}</version>
            </dependency>
        </dependencies>
    </dependencyManagement>

</project>